import React, { Component } from 'react';

class FeedDrivenFlexFeature extends Component {
    constructor(props) {
        super(props)
    }

    renderAuthor(author, index) {
        // TODO make this into a core component
        const { _id = index, name } = author
        return <span key={_id}> <b>{name}</b> </span>
    }

    renderPromoImage(art) {
        // TODO make this into a core component, or use the element_image one
        const { artPosition, imageClasses } = art.configs

        const url = art.basic.url
        const imgJsx = <img width="100%" src={url} />

        if (artPosition === 'left-of-text' || artPosition === 'right-of-text') {
            return <div className={imageClasses}>{imgJsx}</div>
        } else {
            return <div>{imgJsx}</div>
        }
    }

    renderHeadlineAndByline(options) {
        const { section, headlines, url, authors, description, configs } = options
        const { headlineClasses } = configs
        const { name: sectionName } = section

        return (
            <div className={headlineClasses}>
                <h5>{sectionName}</h5>
                <h2><a href={url}>{headlines && headlines.basic}</a></h2>
                <p>{description && description.basic}</p>
                <div>
                    Written by {authors.map((author, index) => this.renderAuthor(author, index))}
                </div>
            </div>
        )
    }

    renderStory({item, config}) {
        
        const { 
            _id, 
            headlines, 
            canonical_url: url,
            description,
            websites,
            credits,
            promo_items
         } = item

        const section = websites && websites[this.props.arcSite].website_section
        const authors = credits && credits.by
        const { artPosition, articleClasses, imageClasses, headlineClasses } = config
        const art = { ...promo_items, configs: { artPosition, imageClasses } }
        const headlineAndByline = { section, headlines, authors, description, url, configs: { headlineClasses } }
        return (
            <article key={_id} className={articleClasses}>
                { art.basic && (artPosition === 'above-text' || artPosition === 'left-of-text') && this.renderPromoImage(art) }
                { this.renderHeadlineAndByline(headlineAndByline) }
                { art.basic && (artPosition === 'below-text' || artPosition === 'right-of-text') && this.renderPromoImage(art) }
            </article>
        )
    }

    render() {
        const stories = JSON.parse(this.props.data)
        const config = JSON.parse(this.props.customFields)

        return <div>{stories && stories.map(story => this.renderStory({ item: story, config }))}</div>
    }
}

export default FeedDrivenFlexFeature;